QB64shell - command line prompt shell windows program for QB64
  contents of commands:

 ALARM [Option]
   ON/OFF - Sets alarm trap on or off.
   SET - Sets seconds per alarm for 9 alarms.
   BEEP - Toggles alarm beeps.
   CLEAR - Clears all alarms.
   LIST - Lists settings for all alarms set.
   COUNT - Displays number of alarms set.
   TYPE - Toggles alarm time display.
   COLOR - Sets alarm colors.
   MUSIC - Toggles alarm music play.
 SCREENSAVER [ON][OFF][BLANK][<n>]
   Turns screensaver on, off, blank, or sets to <n> seconds.
   Specify SCREENSAVER HH:MM:SS for valid time set on.
      Specify SCREENSAVER <n>s valid time set seconds.
      Specify SCREENSAVER <n>m valid time set minutes.
      Specify SCREENSAVER <n>h valid time set hours.
 VIEWFILE [File]
   Prompts and displays info of a filename.
   Where:
     Optional file displays the file info.
 TABLE [Option]
   List current drive table and netpath table.
   Option to search tables. May contain ? and * characters.
 HELP COPY
   Displays user account settings.
   COPY stats:
     (last date on; MM/DD/YYYY HH:MM:SS)
     Files copied: <value>
     Bytes copied: <value>
     Files deleted: <value>
     Files edited: <value>
     Bytes edited: <value>
     Directories copied: <value>
     Directories created: <value>
     Directories deleted: <value>
     Last file saved: <filename>
     Last file edited: <filename>
 SHELL
   Shells to DOS
 SHELL <command>
   Shells to DOS and performs command
 REDRAW
   Redraws the main shell screen.
 MENU
   Starts simple menu function for access to files/directories.
 DATE
   Displays and sets date.
 TIME
   Displays and sets time.
 TOGGLE
   Toggles full screen mode.
 CPU [ON][OFF][MEMORY]
   Turns cpu status on or off.
   'memory' toggles memory usage on or off.
 DEBUG [ON][OFF][TOGGLE]
   Toggles/Turns debug on or off.
   Other debug functions:
     Test - tests a square root of -1
     Error - tests a windows error.
     Errorbox - tests an error box.
     Messagebox - tests the message box.
     Monitorbox - tests the monitor box.
     Timetype - displays the timer type.
     Sound - Plays the THX sound file.
 STATUS [ON][OFF]
   Turns status line on or off.
 KEY [ON][OFF][LIST][RESET][<n>,<text>]
   Turns key statusline on, off, lists current keys, resets keys,
   assigns <text> to a key number to <n> from 1 to 12.
 SYSTEM
   Abort program and exit to system.
 QUIT
   Quit program and exit to system.
 MEM [VIRTUAL][PAGING]
   Display total/free/used physical system RAM.
     'virtual' displays virtual RAM.
     'paging' displays paging file RAM.
 CLOCK
   Display current date and time.
 VER
   Display program version.
 CLS
   Clears text screen viewport.
 EDIT
   Starts the full screen editor.
 HEXCALC
   Starts the Hexidecimal-Decimal calculator.
 ASCII
   Displays charts of ASCII values and characters.
 HEXCHART
   Displays charts of hexidecimal values and characters.
 WHATIS
   Starts the recursive descent parser.
 HELP [COMMAND]
   Displays commands available or help for specific command.
 PROMPT [edit]|[text]
   Changes the QB64shell command prompt.
     text    Specifies a new command prompt.
     edit    Prompts for prompt value.
   Prompt can contain the following special codes:
     $D   Current date      $T   Current time
     $N   Current drive     $P   Current drive and path
     $Q   Current volume    $V   QB64shell version
     $R   QB64shell release $B   QB64shell build
     $H   Backspace         $_   Carriage return and linefeed
     $J   Clear screen      $$   Display a $ character.
     $G   Display > symbol  $L   Display a < symbol
     $M   Display | symbol  $F[x;y]  Set cursor
     $S   Store cursor      $U   Restore cursor
     $X   Display space     $Z   Display clock
     $C[n]  Change foreground color   $E[n]  Change background color
     $W[<exp$>]  Display parsed value $A[<n>]  Insert ascii code.
 COLOR <foreground>,<background>
   Changes the shell prompt color.
   Color code values:
   Fore/Background  Foreground
    0  Black         8  Gray
    1  Blue          9  Light Blue
    2  Green        10  Light green
    3  Cyan         11  Light cyan
    4  Red          12  Light red
    5  Magenta      13  Light magenta
    6  Brown        14  Yellow
    7  White        15  High-intensity white
 QB64shell commands:
 Basic commands:
   CLS     CPU       KEY       MEM       VER      TOGGLE   MONITOR
   CLOCK   DATE      TIME      MENU      HELP     EDIT     PROFILES
   DEBUG   COLOR     PROMPT    STATUS    SYSTEM   QUIT     SCREENSAVER
   ASCII   HEXCHART  HEXCALC   REDRAW    WHATIS   COUNT    TABLE    ALARM
 Filters:  FIND      MORE      SORT      TYPE
 Filename commands:
   COMPFILE COPY     DELETE    DIR/FILES MKFILE    RENAME
   ENCRYPT  DECRYPT  GETATTR   SETATTR   LISTFILE  TOUCHFILE
 Directory commands: COMPDIR   LISTDIR   PUSHD     POPD
   TREEDIR  TREEDEL  TOUCHDIR  CHDIR     MKDIR     RMDIR
 Volume commands:
   DRIVES   LABEL    VOL       LISTDRIVE SERIAL    FATTYPE
 See also "HELP STREAM" for additional command parsing.
 Streaming is done using the following symbols on the command line:
   <  redirect input from file.
   >  redirect output to file.
   >>  append redirected output to file.
   >>>  append errors to file.
   |   redirect i/o from command to next.
 Example usage:
    Dir *.lst /c | Copyit /dtemp /c
    Treedir temp*.* /r/b/c | Dir *.lst /c
    Type Filelist.txt /c | Sort /c > output.lst
 PROFILES [ON][OFF][LIST][EDIT]
   Turns profiles on or off, lists profiles, edits profiles.
 MONITOR [ON][OFF][LIMIT][TIMER]
   Turns memory monitor on or off, sets limit and timer.
      Limit is free RAM in MB. For example, MONITOR LIMIT=20
      Timer is checking in seconds. For example, MONITOR TIMER=60
 PUSHD <path/netpath>
   Pushs a fully qualified pathname or a network pathname
   on the stack and moves default prompt to the path.
 POPD
   Pops the current path off the stack.
 COMPDIR [COUNT] [/F"path" /G"path"]
   Compares the files in two directories for equivalent
   files of same name, size, and content.
   Optional COUNT only displays number of matching files.
   Optional /F"path" with G/"path" matchs specified paths."
 COMPFILE [LIST] [/F"file" /G"file"]
   Compares two files for equivalent size and contents.
   Optional LIST displays table of offsets and hex/ascii values.
   Optional /F"file" with G/"file" matchs specified files."
 LISTFILE [<spec>]
   Lists files and files in a specification.
 Where the 7 attributes from left to right are:
   A - archive
   D - directory
   S - system
   R - read-only
   H - hidden
   C - compressed
   E - encrypted
 LISTDIR [<spec>]
   Lists directories and directories in a specification.
 Where the 7 attributes from left to right are:
   A - archive
   D - directory
   S - system
   R - read-only
   H - hidden
   C - compressed
   E - encrypted
 LISTDRIVE [<spec>]
   Lists current drives, and their labels, volume types, and
   free/total/used space. Also specify drive letters as parameters.

-end-
