REM nastiest folder/file delete function ever written..
REM   distribution NOT allowed!

' declare library constants.
CONST MAX_PATH = 260
CONST INVALID_HANDLE_VALUE = -1

' declare library structures.
TYPE FILETIME
    dwLowDateTime AS _UNSIGNED LONG
    dwHighDateTime AS _UNSIGNED LONG
END TYPE

TYPE SYSTEMTIME
    wYear AS INTEGER
    wMonth AS INTEGER
    wDayOfWeek AS INTEGER
    wDay AS INTEGER
    wHour AS INTEGER
    wMinute AS INTEGER
    wSecond AS INTEGER
    wMilliseconds AS INTEGER
END TYPE

TYPE WIN32_FIND_DATAA
    dwFileAttributes AS _UNSIGNED LONG
    ftCreationTime AS FILETIME
    ftLastAccessTime AS FILETIME
    ftLastWriteTime AS FILETIME
    nFileSizeHigh AS _UNSIGNED LONG
    nFileSizeLow AS _UNSIGNED LONG
    dwReserved0 AS _UNSIGNED LONG
    dwReserved1 AS _UNSIGNED LONG
    cFileName AS STRING * MAX_PATH
    cAlternateFileName AS STRING * 14
END TYPE

' declare external libraries.
DECLARE DYNAMIC LIBRARY "kernel32"
    FUNCTION DeleteFileA% (F$)
    FUNCTION FindFirstFileA~%& (BYVAL lpFileName~%&, BYVAL lpFindFileData~%&)
    FUNCTION FindNextFileA& (BYVAL hFindFile~%&, BYVAL lpFindFileData~%&)
    FUNCTION FindClose& (BYVAL hFindFile~%&)
    FUNCTION RemoveDirectoryA% (F$)
END DECLARE

DECLARE LIBRARY
    FUNCTION GetFileAttributes& (f$)
    FUNCTION SetFileAttributes& (f$, BYVAL a&)
END DECLARE
_TITLE "DELETE"
PRINT "Enter directory to delete";: INPUT G$
IF _DIREXISTS(G$) = 0 THEN
    PRINT "Directory not fuund."
    END
END IF
PRINT "Delete directory and all subfolders/files(y/n)?"
DO
    _LIMIT 100
    x$ = LCASE$(INKEY$)
    IF x$ = "n" THEN END
    IF x$ = "y" THEN PRINT: PRINT "OK..": EXIT DO
LOOP
IF RIGHT$(G$, 1) <> "\" THEN G$ = G$ + "\"
CALL Silentdel_Directories(G$)
IF _DIREXISTS(G$) = 0 THEN
    PRINT "Directory deleted."
ELSE
    PRINT "Error deleting directory."
END IF
END

' subroutine to access subdirectories
SUB Silentdel_Directories (Directory.Search$)
    ' declare subroutine variables
    DIM Attribute AS _UNSIGNED LONG
    DIM ASCIIZ AS STRING * 260
    DIM finddata AS WIN32_FIND_DATAA
    DIM Wfile.Handle AS _UNSIGNED _OFFSET

    ' make directory filename
    ASCIIZ = Directory.Search$ + "*.*" + CHR$(0)

    ' start directory search
    Wfile.Handle = FindFirstFileA(_OFFSET(ASCIIZ), _OFFSET(finddata))
    IF Wfile.Handle <> INVALID_HANDLE_VALUE THEN

        ' delete filenames
        CALL Silentdel_DeleteFiles(Directory.Search$)

        ' recurse subdirectories
        DO
            ' check directory attribute
            Attribute = finddata.dwFileAttributes

            ' check directory
            IF (Attribute AND &H10) = &H10 THEN

                ' store directory name
                Directory$ = finddata.cFileName
                Directory$ = LEFT$(Directory$, INSTR(Directory$, CHR$(0)) - 1)

                ' store short filename
                IF INSTR(Directory$, "?") THEN
                    Directory$ = finddata.cAlternateFileName
                    V = INSTR(Directory$, CHR$(0))
                    IF V THEN Directory$ = LEFT$(Directory$, V - 1)
                END IF

                ' check directory name
                IF Directory$ <> "." AND Directory$ <> ".." THEN

                    ' make next search directory
                    Next.Directory$ = Directory.Search$ + Directory$ + "\"

                    ' recursively search subdirectories
                    CALL Silentdel_Directories(Next.Directory$)
                END IF
            END IF
        LOOP WHILE FindNextFileA(Wfile.Handle, _OFFSET(finddata))
        x = FindClose(Wfile.Handle)
    END IF

    ' delete directory
    CALL Silentdel_DeleteDirectory(Directory.Search$)
END SUB

' subroutine to delete an empty directory
SUB Silentdel_DeleteDirectory (Directory$)
    ' declare subroutine variables
    DIM ASCIIZ AS STRING * 260

    ' store directory filename
    ASCIIZ = Directory$ + CHR$(0)

    ' change directory attribute
    AttrX& = GetFileAttributes(ASCIIZ)
    AttrX& = AttrX& AND NOT &H1 ' remove read-only bit
    x = SetFileAttributes&(ASCIIZ, AttrX&)

    ' delete directory
    x = RemoveDirectoryA(ASCIIZ)
END SUB

' subroutine to delete files in a directory
SUB Silentdel_DeleteFiles (Directory$)
    ' declare subroutine variables
    DIM Attribute AS _UNSIGNED LONG
    DIM ASCIIZ AS STRING * 260
    DIM ASCIIZ2 AS STRING * 260
    DIM finddata AS WIN32_FIND_DATAA
    DIM Wfile.Handle AS _UNSIGNED _OFFSET

    ' make filename
    ASCIIZ = Directory$ + "*.*" + CHR$(0)

    Wfile.Handle = FindFirstFileA(_OFFSET(ASCIIZ), _OFFSET(finddata))
    IF Wfile.Handle <> INVALID_HANDLE_VALUE THEN

        ' filename loop
        DO
            ' store filename
            Filename$ = finddata.cFileName
            Filename$ = LEFT$(Filename$, INSTR(Filename$, CHR$(0)) - 1)

            ' check filename
            IF Filename$ <> "." AND Filename$ <> ".." THEN
                ' store filename
                ASCIIZ2 = Directory$ + Filename$ + CHR$(0)

                ' change filename attribute
                AttrX& = GetFileAttributes(ASCIIZ2)
                AttrX& = AttrX& AND NOT &H1 ' remove read-only bit
                x = SetFileAttributes&(ASCIIZ2, AttrX&)

                ' delete long filename
                x = DeleteFileA(ASCIIZ2)

                ' check error and delete 8.3 filename
                IF x = 0 THEN
                    Short.Filename$ = finddata.cAlternateFileName
                    V = INSTR(Short.Filename$, CHR$(0))
                    IF V THEN Short.Filename$ = LEFT$(Short.Filename$, V - 1)
                    ASCIIZ2 = Directory$ + Short.Filename$ + CHR$(0)

                    ' change filename attribute
                    AttrX& = GetFileAttributes(ASCIIZ2)
                    AttrX& = AttrX& AND NOT &H1
                    x = SetFileAttributes&(ASCIIZ2, AttrX&)

                    ' delete short filename
                    x = DeleteFileA(ASCIIZ2)
                END IF
            END IF
        LOOP WHILE FindNextFileA(Wfile.Handle, _OFFSET(finddata))
        x = FindClose(Wfile.Handle)
    END IF
END SUB

